package com.dayou.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dayou.configuration.BaseEntity;
import com.dayou.configuration.ErrorCode;
import com.dayou.dao.CycleMapper;
import com.dayou.entity.Cycle;
import com.dayou.service.ICycleService;
import com.dayou.vo.CycleVO;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 类说明：
 *
 * @author: wucl
 * @since: 2023/7/20
 * created with IntelliJ IDEA.
 */
@Service
public class CycleServiceImpl extends ServiceImpl<CycleMapper, Cycle> implements ICycleService {

    @Autowired
    private CycleMapper cycleMapper;

    @Override
    public IPage<CycleVO> getPage(Page page, CycleVO cycleVO) {
        IPage<CycleVO> result = cycleMapper.getPage(page,cycleVO);
        return result;
    }

    @Override
    public Boolean saveCycle(Cycle cycle) {
        List<Cycle> list = this.list(new LambdaQueryWrapper<Cycle>().eq(Cycle::getDocumentId, cycle.getDocumentId())
                .eq(Cycle::getCycleName, cycle.getCycleName()).eq(BaseEntity::getDeleted, Boolean.FALSE));
        if (CollectionUtils.isEmpty(list)){
            return this.save(cycle);
        }else {
            ErrorCode.throwBusinessException(ErrorCode.CUSTOM_ERROR,"该问卷此轮已存在。");
            return Boolean.FALSE;
        }
    }
}
