package com.dayou.utils;

import com.dayou.entity.User;

import java.util.Optional;

/**
 * 类说明：
 *
 * @author: wucl
 * @since: 2023/7/12
 * created with IntelliJ IDEA.
 */
public class LoginContext {

    private static final ThreadLocal<User> loginThreadLocal = new ThreadLocal<>();

    public static void setUser(User  user){
        loginThreadLocal.set(user);
    }

    public static User getCurrentUser(){
        return Optional.ofNullable(loginThreadLocal.get()).orElseGet(User::new);
    }

    public static void removeAll() {
        loginThreadLocal.remove();
    }
}
